"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _path() {
  const data = require("path");

  _path = function _path() {
    return data;
  };

  return data;
}

function _umi() {
  const data = require("umi");

  _umi = function _umi() {
    return data;
  };

  return data;
}

var _utils = require("./utils");

function _fs() {
  const data = require("fs");

  _fs = function _fs() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const DIR_NAME = 'plugin-core-preset';
const LOADING_ID = 'lins-module-loading';

function _default(api) {
  api.logger.info('use core-preset plugin');
  api.describe({
    key: 'core',
    config: {
      schema(joi) {
        return joi.object({
          disable: joi.boolean(),
          dictionary: joi.array().items(joi.string()),
          //子模块是否开启loading
          // disableLoading: joi.boolean(),
          loading: joi.any()
        });
      }

    }
  });
  api.addDepInfo(() => {
    var _api$pkg$dependencies, _api$pkg$devDependenc;

    const pkg = require('../package.json');

    console.log(api.pkg);
    return [{
      name: '@sensoro/core',
      range: ((_api$pkg$dependencies = api.pkg.dependencies) === null || _api$pkg$dependencies === void 0 ? void 0 : _api$pkg$dependencies['@sensoro/core']) || ((_api$pkg$devDependenc = api.pkg.devDependencies) === null || _api$pkg$devDependenc === void 0 ? void 0 : _api$pkg$devDependenc['@sensoro/core']) || pkg.peerDependencies['@sensoro/core']
    }];
  });

  function haveCorePackage() {
    try {
      // require.resolve('@sensoro/core');
      return true;
    } catch (error) {
      console.log(error);
      console.error('umi-plugin-core-preset 需要安装 @sensoro/core 才可运行');
    }

    return false;
  }

  const _api$userConfig = api.userConfig,
        _api$userConfig$core = _api$userConfig.core,
        core = _api$userConfig$core === void 0 ? {} : _api$userConfig$core,
        _api$userConfig$qiank = _api$userConfig.qiankun,
        qiankun = _api$userConfig$qiank === void 0 ? {
    master: {}
  } : _api$userConfig$qiank,
        dynamicImport = _api$userConfig.dynamicImport,
        publicPath = _api$userConfig.publicPath;
  const disable = core.disable,
        _core$dictionary = core.dictionary,
        dictionary = _core$dictionary === void 0 ? [] : _core$dictionary;

  if (qiankun) {
    if (haveCorePackage() && !disable) {
      if (qiankun.slave) {
        // if (!disableLoading) {
        //   api.addRuntimePlugin(() => `@@/${DIR_NAME}/app-loading-plugin`);
        //   api.onGenerateFiles(() => {
        //     api.writeTmpFile({
        //       path: `${DIR_NAME}/app-loading-plugin.ts`,
        //       content: readFileSync(
        //         join(__dirname, 'app-loading-plugin.ts.tpl'),
        //         'utf-8',
        //       ),
        //     });
        //   });
        // }
        api.onGenerateFiles(() => {
          api.writeTmpFile({
            path: (0, _path().join)(DIR_NAME, 'index.tsx'),
            content: (0, _utils.getContet)(JSON.stringify(dictionary))
          });
        });
        api.modifyRoutes(routes => {
          return [{
            path: '/',
            component: _umi().utils.winPath((0, _path().join)(api.paths.absTmpPath || '', DIR_NAME, 'index.tsx')),
            routes
          }];
        }); //如果是动态加载

        if (!!dynamicImport && !!publicPath) {
          const trimPath = publicPath.slice(1);
          api.addHTMLHeadScripts(() => {
            return [{
              content: `
                if(window.__INJECTED_PUBLIC_PATH_BY_QIANKUN__){
                  window.__INJECTED_PUBLIC_PATH_BY_QIANKUN__ += "${trimPath}";
                }
                `
            }];
          });
          api.addRuntimePlugin(() => `@@/${DIR_NAME}/dynamic-import-plugin`);
          api.onGenerateFiles(() => {
            api.writeTmpFile({
              path: `${DIR_NAME}/dynamic-import-plugin.ts`,
              content: (0, _fs().readFileSync)((0, _path().join)(__dirname, 'dynamic-import-plugin.ts.tpl'), 'utf-8')
            });
          });
        }

        if (core.loading === false) {
          api.logger.info('disable loading');
        } else {
          const _core$loading = core.loading,
                loading = _core$loading === void 0 ? {} : _core$loading;
          const _loading$url = loading.url,
                url = _loading$url === void 0 ? 'https://lins-cdn.sensoro.com/lins-cdn/assets/lins_loading.gif' : _loading$url,
                _loading$top = loading.top,
                top = _loading$top === void 0 ? 64 : _loading$top,
                _loading$zIndex = loading.zIndex,
                zIndex = _loading$zIndex === void 0 ? 999 : _loading$zIndex,
                _loading$width = loading.width,
                width = _loading$width === void 0 ? 400 : _loading$width,
                _loading$height = loading.height,
                height = _loading$height === void 0 ? 300 : _loading$height;
          api.addHTMLScripts(() => {
            return [{
              content: `
                var existLoading = window.document.querySelector('#${LOADING_ID}');
                if(!!existLoading){
                  window.document.removeChild(existLoading);
                }
                var loading = window.document.createElement('div');
                loading.id = '${LOADING_ID}';
                loading.style.position = 'absolute';
                loading.style.top = '${top}px';
                loading.style.left = '0px';
                loading.style.right = '0px';
                loading.style.bottom = '0px';
                loading.style.zIndex = '${zIndex}';
                loading.style.paddingTop = '170px';
                loading.style.background = 'white';
                loading.style.display = 'flex';
                loading.style.justifyContent = 'center';
                loading.innerHTML = '<img src="${url}" width="${width}" height="${height}" />';
                var object = window.document.body.appendChild(loading);
                `
            }];
          });
        }
      }
    }
  } else {
    api.logger.warn('该插件只适用于umi-qiankun项目，skip');
  }
}